//colorconversion.c
//aroetter@graphics

#include "colorconversion.h"
#include <stdio.h>


/* converts a color image down to 2 bit, using a simple threshold
 * dither, the color to use is given by argument color, where
 * red = 0, green = 1, blue = 2, average = 3
 * and the threshold value is give by the other variable, and can be between
 * 0 and 255
 */
//rgbimg must be 3 dimensional rgb and img must be 1d--can also be 3d
//need to test this function
void binarygrayscale(Image &rgbimg, Image &img, int color, int threshold)
{
  int u, v;
  int width = img.width();
  int height = img.height();
  uchar pix;
  printf("color=%d\n", color);
  for(u = 0; u < width; u++)
    for(v = 0; v < height; v++)
      {
	if (color == 0) pix = rgbimg.getR(u,v);
	else if (color == 1) pix = rgbimg.getG(u,v);
	else if (color == 2) pix = rgbimg.getB(u,v);
	else if (color == 3) pix = (rgbimg.getR(u,v) +
				    rgbimg.getG(u,v) +
	    			    rgbimg.getB(u,v))/3;


	if (pix > threshold)
		img.setValue(u,v,255,255,255);
	else
		img.setValue(u,v,0,0,0);
      }
}
 


//converts a color image into a grayscale image
//gray can be either 1d or 3d
void color2grayscale(Image &color, Image &gray)
{
  int u,v;
  int rows = color.width();
  int cols = color.height();
  int grayval;

  for(u = 0; u < rows; u++)
    {
      for(v = 0; v < cols; v++)
	{
	  grayval = 30 * color.getR(u,v) +
	    59 * color.getG(u,v) +
	    11 * color.getB(u,v);
	  grayval = (grayval+50)/100;
	  //gray.setValue(u,v,grayval);
	  gray.setValue(u,v,grayval,grayval,grayval);
	}
    }
}
 




